/**
 * Gate API v4
 * APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.GateApi) {
      root.GateApi = {};
    }
    root.GateApi.Currency = factory(root.GateApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';


  /**
   * The Currency model module.
   * @module model/Currency
   */

  /**
   * Constructs a new <code>Currency</code>.
   * @alias module:model/Currency
   * @class
   */
  var exports = function() {
    var _this = this;

  };

  /**
   * Constructs a <code>Currency</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Currency} obj Optional instance to populate.
   * @return {module:model/Currency} The populated <code>Currency</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('currency')) {
        obj['currency'] = ApiClient.convertToType(data['currency'], 'String');
      }
      if (data.hasOwnProperty('delisted')) {
        obj['delisted'] = ApiClient.convertToType(data['delisted'], 'Boolean');
      }
      if (data.hasOwnProperty('withdraw_disabled')) {
        obj['withdraw_disabled'] = ApiClient.convertToType(data['withdraw_disabled'], 'Boolean');
      }
      if (data.hasOwnProperty('withdraw_delayed')) {
        obj['withdraw_delayed'] = ApiClient.convertToType(data['withdraw_delayed'], 'Boolean');
      }
      if (data.hasOwnProperty('deposit_disabled')) {
        obj['deposit_disabled'] = ApiClient.convertToType(data['deposit_disabled'], 'Boolean');
      }
      if (data.hasOwnProperty('trade_disabled')) {
        obj['trade_disabled'] = ApiClient.convertToType(data['trade_disabled'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Currency name
   * @member {String} currency
   */
  exports.prototype['currency'] = undefined;
  /**
   * Whether currency is de-listed
   * @member {Boolean} delisted
   */
  exports.prototype['delisted'] = undefined;
  /**
   * Whether currency's withdrawal is disabled
   * @member {Boolean} withdraw_disabled
   */
  exports.prototype['withdraw_disabled'] = undefined;
  /**
   * Whether currency's withdrawal is delayed
   * @member {Boolean} withdraw_delayed
   */
  exports.prototype['withdraw_delayed'] = undefined;
  /**
   * Whether currency's deposit is disabled
   * @member {Boolean} deposit_disabled
   */
  exports.prototype['deposit_disabled'] = undefined;
  /**
   * Whether currency's trading is disabled
   * @member {Boolean} trade_disabled
   */
  exports.prototype['trade_disabled'] = undefined;



  return exports;
}));

